#include <DualWheelTruck.h> // Подключение библиотеки <DualWheelTruck.h> для работы с моторами

#define LEFT_LED 6 // Назначение пина, к которому подключен левый светодиод
#define RIGHT_LED 11 // Назначение пина, к которому подключен правый светодиод
#define BUTTON_REJIM 5 // Назначение пина, к которому подключена тактовая кнопка выбора режима работы
#define BUTTON_START 13 // Назначение пина, к которому подключена тактовая кнопка запуска робота
#define ENCODER_LEFT 9 // Назначение пина, к которому подключен левый энкодер
#define ENCODER_RIGHT 10 // Назначение пина, к которому подключен правый энкодер

#define d_koles 64 // Б.1 - Объявление константы d_koles (диаметр колеса) с значением 64
#define okr_koles 3.14*d_koles // Б.2 - Объявление константы okr_koles (длина окружности колеса) с значением 3.14*d_koles
#define disk_sector 36 // Б.1 - Объявление константы disk_sector (количество секторов на черно-белом диске) с значением 36
float rastojan=okr_koles/disk_sector; // Б.2 - Объявление переменной rastojan (расстояние, проходимо колесом при повороте на один сектор черно-белого диска) и присвоение ей значения okr_koles/disk_sector

bool button_state; // Объявление переменной button_state
bool robot_state=false; // Б.1 - Объявление переменной robot_state и присвоение ей значения false
bool right_encoder_state; // Объявление переменной right_encoder_state
bool left_encoder_state; // Объявление переменной left_encoder_state
bool right_encoder_state_was; // Объявление переменной right_encoder_state_was
bool left_encoder_state_was; // Объявление left_encoder_state_was left_encoder_state

int rejim=4; // Б.1 - Объявление переменной rejim и присвоение ей значения 4
int speeds_r=100; // Б.1 - Объявление переменной speeds_r и присвоение ей значения 100
int speeds_l=100; // Б.1 - Объявление переменной speeds_r и присвоение ей значения 100
int distance; // Объявление переменной distance 
int counter; // Объявление переменной counter
int counter_r; // Объявление переменной counter_r
int counter_l; // Объявление переменной counter_l
int error; // Объявление переменной error

void button_read(); // Объявление функции обработки состояния кнопки запуска
void zapusk(); // Объявление функции подготовки робота к работе
void go_forward(); // Объявление функции прямолинейного движения робота

DCMotor* motor_right; // Инициализация мотора и присвоение ему имени motor_right
DCMotor* motor_left; // Инициализация мотора и присвоение ему имени motor_left

void setup() {
Board::vertor_PCA(); // Объявление типа используемого контроллера - vertor_PCA

motor_right = new DCMotor(1, 0, true, 5); // Настройка мотора motor_right с применением функции DCMotor(a, b, c, d): подключен к клеммнику 1, прямая полярность подключения мотора, инерционность 5
motor_left = new DCMotor(0, 0, false, 5); // Настройка мотора motor_left с применением функции DCMotor(a, b, c, d): подключен к клеммнику 0, обратная полярность подключения мотора, инерционность 5

motor_right->stop(false); // Команда на остановку вращения мотора motor_right
motor_left->stop(false); // Команда на остановку вращения мотора motor_left
 
pinMode (LEFT_LED,OUTPUT); // Настройка пина LEFT_LED на вывод
pinMode (RIGHT_LED,OUTPUT); // Настройка пина RIGHT_LED на вывод
pinMode (BUTTON_REJIM,INPUT); // Настройка пина BUTTON_REJIM на ввод
pinMode (BUTTON_START,INPUT); // Настройка пина BUTTON_START на ввод
pinMode (ENCODER_LEFT,INPUT); // Настройка пина ENCODER_LEFT на ввод
pinMode (ENCODER_RIGHT,INPUT); // Настройка пина ENCODER_RIGHT на ввод

right_encoder_state_was=digitalRead(ENCODER_RIGHT); // Б.3,4 - Сохранение состояния на пине ENCODER_RIGHT в переменную right_encoder_state_was
left_encoder_state_was=digitalRead(ENCODER_LEFT); // Б.3,4 - Сохранение состояния на пине ENCODER_LEFT в переменную left_encoder_state_was
}

void loop() {  
  button_state=digitalRead(BUTTON_REJIM); // Б.5 - Сохранение состояния на пине BUTTON_REJIM в переменную button_state
  if(button_state==0) // Б.6 - Если значение переменной button_state равно 0, то 
  {
     rejim++; // Б.7 - Увеличение значения переменной rejim на 1     
     do 
     {
      button_state=digitalRead(BUTTON_REJIM); // Б.8 - Сохранение состояния на пине BUTTON_REJIM в переменную button_state
     }
      while(button_state==0); // Б.9 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
  } 
  
  if(rejim==2) // Б.10 - Если значение переменной rejim равно 2, то 
  {
  digitalWrite(LEFT_LED,HIGH); // Б.11 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"  
  digitalWrite(RIGHT_LED,LOW); // Б.11 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW" 
  distance=1000; // Б.12 - Присвоение переменной distance значения 1000
  }
  else if(rejim==3) // Б.13 - Если значение переменной rejim равно 3, то 
  {  
  digitalWrite(LEFT_LED,HIGH); // Б.14 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"  
  digitalWrite(RIGHT_LED,HIGH); // Б.14 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH" 
  distance=1500; // Б.15 - Присвоение переменной distance значения 1500  
  }
  else if(rejim==4) // Б.16 - Если значение переменной rejim равно 4, то 
  {
  rejim=1; // Б.17 - Присвоение переменной rejim значения 1   
  digitalWrite(LEFT_LED,LOW);  // Б.18 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
  digitalWrite(RIGHT_LED,HIGH);  // Б.18 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH" 
  distance=500; // Б.19 - Присвоение переменной distance значения 500 
  }
  
  button_read(); // Б.20 - Вызов функции обработки состояния кнопки запуска

if(robot_state==true) // Б.21 - Если значение переменной robot_state равно true, то начать выполнение инструкций в скобках 
{
  zapusk(); // Б.22 - Вызов функции подготовки робота к работе
  moves(distance); // Б.23 - Вызов функции, обеспечивающей движение робота вперед на расстояние distance    
  robot_state=false; // Б.24 - Присвоение переменной robot_state значения false  
  motor_right->stop(false); // Б.25 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.25 - Команда на остановку вращения мотора motor_left
  if (rejim==1) // Б.26 - Если значение переменной rejim равно 1, то выполнить инструкцию в скобках
  {
   rejim=4; // Б.27 - Присвоение переменной rejim значения 4
  }
}      
}

void button_read()
{
  button_state=digitalRead(BUTTON_START); // Б.20.1 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.20.2 - Если значение переменной button_state равно 0, то 
  {
  delay(10); // Б.20.3 - Ожидание 0,01 секунды
  button_state=digitalRead(BUTTON_START); // Б.20.4 - Сохранение состояния на пине BUTTON_START в переменную button_state
  if(button_state==0) // Б.20.5 - Если значение переменной button_state равно 0, то 
  {
  do 
  {
   button_state=digitalRead(BUTTON_START); // Б.20.6 - Сохранение состояния на пине BUTTON_START в переменную button_state
  }
  while(button_state==0); // Б.20.7 - Цикл do while() выполнять до тех пор, пока значение переменной button_state равно 0
   robot_state=true; // Б.20.8 - Присвоение переменной robot_state значение true   
  }
  }
}

void zapusk()
{
  counter=0; // Б.22.1 - Присвоение переменной counter значения 0
  while(counter<3) // Б.22.2 - Инициализация цикла While()
                   // Выполнение цикла, пока значение переменной counter меньше 3                                     
  {
   digitalWrite(LEFT_LED,HIGH); // Б.22.3 - Установить на пине LEFT_LED напряжение, соответствующее уровню "HIGH"
   digitalWrite(RIGHT_LED,HIGH); // Б.22.3 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "HIGH"
   delay(500); // Б.22.4 - Ожидание 0,5 секунды
   digitalWrite(LEFT_LED,LOW); // Б.22.5 - Установить на пине LEFT_LED напряжение, соответствующее уровню "LOW"
   digitalWrite(RIGHT_LED,LOW); // Б.22.5 - Установить на пине RIGHT_LED напряжение, соответствующее уровню "LOW"
   delay(500); // Б.22.6 - Ожидание 0,5 секунды
   counter=counter+1; // Б.22.7 - Увеличение значения переменной counter на 1
  }     
}

void moves(float znachenie) // Функция поворота робота. Принимает значение перемещения робота znachenie и тип перемещения napravlenie
{
  counter_r=int(znachenie/rastojan); // Б.23.1 - Присвоение переменной counter_r значения, рассчитанного по формуле: znachenie/rastojan
  counter_l=counter_r; // Б.23.2 - Присвоение переменной counter_l значение переменной counter_r
  
  while(counter_r>0||counter_l>0) // Б.23.3 - Цикл While() выполнять до тех пор, пока значение переменной counter_r больше 0 или значение перменной counter_l больше 0
  {  
  motor_right->forward(speeds_r); // Б.23.4 - Команда на запуск мотора motor_right со скоростью speeds % в прямом направлении
  motor_left->forward(speeds_l); // Б.23.4 - Команда на запуск мотора motor_left со скоростью speeds % в прямом направлении
  right_encoder_state=digitalRead(ENCODER_RIGHT); // Б.23.5 - Сохранение состояния на пине ENCODER_RIGHT в переменную right_encoder_state
  left_encoder_state=digitalRead(ENCODER_LEFT); // Б.23.5 - Сохранение состояния на пине ENCODER_LEFT в переменную left_encoder_state
  
  if(right_encoder_state!=right_encoder_state_was) // Б.23.6 - Если значение переменной right_encoder_state не совпадает со значением переменной right_encoder_state_was, то выполнять инструкции в скобках
  {    
    counter_r=counter_r-1; // Б.23.7 - Уменьшение значения переменной counter_r на 1 
    error=counter_r-counter_l; // Б.23.8 - Присвоение переменной error значения, равного разности значений переменных counter_r и counter_l
    speeds_r=80+error*10; // Б.23.9 - Присвоение переменной speeds_r значения, рассчитанного по формуле: 80+error*10
    speeds_l=80-error*10; // Б.23.9 - Присвоение переменной speeds_l значения, рассчитанного по формуле: 80-error*10
  }
  if(left_encoder_state!=left_encoder_state_was) // Б.23.10 - Если значение переменной left_encoder_state не совпадает со значением переменной left_encoder_state_was, то выполнять инструкции в скобках
  {
    counter_l=counter_l-1; // Б.23.11 - Уменьшение значения переменной counter_l на 1    
    error=counter_r-counter_l; // Б.23.12 - Присвоение переменной error значения, равного разности значений переменных counter_r и counter_l
    speeds_r=80+error*10; // Б.23.13 - Присвоение переменной speeds_r значения, рассчитанного по формуле: 80+error*10
    speeds_l=80-error*10; // Б.23.13 - Присвоение переменной speeds_l значения, рассчитанного по формуле: 80-error*10
  }  
  
  if(counter_r==0&&counter_l==0) // Б.23.14 - Если значение перменных counter_r и counter_l равно 0, то начать выполнение инструкций в скобках 
  {
  motor_right->backward(90); // Б.23.15 - Команда на запуск мотора motor_right со скоростью speeds % в обратном направлении
  motor_left->backward(90); // Б.23.15 - Команда на запуск мотора motor_left со скоростью speeds % в обратном направлении
  delay(10); // Б.23.16 - Ожидание 0,01 секунды
  motor_right->stop(false); // Б.23.17 - Команда на остановку вращения мотора motor_right
  motor_left->stop(false); // Б.23.17 - Команда на остановку вращения мотора motor_left
  }

  delay(10); // Б.23.18 - Ожидание 0,01 секунды
  right_encoder_state_was=right_encoder_state; // Б.23.19 - Присвоение переменной right_encoder_state_was значения переменной right_encoder_state
  left_encoder_state_was=left_encoder_state; // Б.23.19 - Присвоение переменной left_encoder_state_was значения переменной left_encoder_state
}
}
